#include "Quantize_aux.h"

void quantize(int odd, int *in_blockeven, int *in_blockodd, int *out_block) {
	int i,  m,  q,  o;
	int *in_block;

	if (odd == 0) 
		in_block = in_blockeven;
	else
		in_block = in_blockodd;
		

	q = LuminanceQuantization[0];

	for (i=0; i<64; i++)
	{
		m = in_block[i];
		if (m > 0)
		{
			o = (m + q/2) / q;
		}
		else
		{
			o = (m - q/2) / q;
		}
		if (i < 63)
		{
			q = LuminanceQuantization[i+1];
		}
		out_block[i] = o;
	}
}

