#ifdef SC

#include "fixed.h"
//void rpcm_imdct36 (mad_fixed_t const x[18], mad_fixed_t y[36])
void rpcm_imdct36()
{
mad_fixed_t y[36];
mad_fixed_t x[18];
while(1){
        recv_P_ID_rpcm_imdct36_P_ID_mp3_main(x,sizeof(mad_fixed_t[18]));
    int tmp[18];
    int i;


  //xil_printf("--------Starting imdct36 ----- \n");

    /* scale[i] = 2 * cos(PI * (2 * i + 1) / (4 * 18)) */
    int const scale[18] = {
      MAD_F(0x1ff833fa), MAD_F(0x1fb9ea93), MAD_F(0x1f3dd120),
      MAD_F(0x1e84d969), MAD_F(0x1d906bcf), MAD_F(0x1c62648b),
      MAD_F(0x1afd100f), MAD_F(0x1963268b), MAD_F(0x1797c6a4),
      MAD_F(0x159e6f5b), MAD_F(0x137af940), MAD_F(0x11318ef3),
      MAD_F(0x0ec6a507), MAD_F(0x0c3ef153), MAD_F(0x099f61c5),
      MAD_F(0x06ed12c5), MAD_F(0x042d4544), MAD_F(0x0165547c)
    };

    /* scale[i] = 2 * cos(PI * (2 * i + 1) / (2 * 18)) */
    int const sdct_scale[9] = {
      MAD_F(0x1fe0d3b4), MAD_F(0x1ee8dd47), MAD_F(0x1d007930),
      MAD_F(0x1a367e59), MAD_F(0x16a09e66), MAD_F(0x125abcf8),
      MAD_F(0x0d8616bc), MAD_F(0x08483ee1), MAD_F(0x02c9fad7)
    };

    int dctIV_tmp[18];
    int sdct_tmp[9];

    int fast_y[17];
    int a0,  a1,  a2,  a3,  a4,  a5,  a6,  a7,  a8,  a9,  a10, a11, a12;
    int a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25;
    int m0,  m1,  m2,  m3,  m4,  m5,  m6,  m7;

    int const c0 =  MAD_F(0x1f838b8d);  /* 2 * cos( 1 * PI / 18) */
    int const c1 =  MAD_F(0x1bb67ae8);  /* 2 * cos( 3 * PI / 18) */
    int const c2 =  MAD_F(0x18836fa3);  /* 2 * cos( 4 * PI / 18) */
    int const c3 =  MAD_F(0x1491b752);  /* 2 * cos( 5 * PI / 18) */
    int const c4 =  MAD_F(0x0af1d43a);  /* 2 * cos( 7 * PI / 18) */
    int const c5 =  MAD_F(0x058e86a0);  /* 2 * cos( 8 * PI / 18) */
    int const c6 = -MAD_F(0x1e11f642);   /* 2 * cos(16 * PI / 18) */

    /* DCT-IV */

//    imdct_count++;
    /*  dctIV(x, tmp); manual in-line */
    {
      /* scaling */
      for (i = 0; i < 18; i += 3) {
        dctIV_tmp[i + 0] = mad_f_mul(x[i + 0], scale[i + 0]);
        dctIV_tmp[i + 1] = mad_f_mul(x[i + 1], scale[i + 1]);
        dctIV_tmp[i + 2] = mad_f_mul(x[i + 2], scale[i + 2]);
      }

      /* SDCT-II */

      /* sdctII(dctIV_tmp, tmp);  manual in-line */
      {
        /* divide the 18-point SDCT-II into two 9-point SDCT-IIs */

        /* even input butterfly */

        for (i = 0; i < 9; i += 3) {
          sdct_tmp[i + 0] = dctIV_tmp[i + 0] + dctIV_tmp[18 - (i + 0) - 1];
          sdct_tmp[i + 1] = dctIV_tmp[i + 1] + dctIV_tmp[18 - (i + 1) - 1];
          sdct_tmp[i + 2] = dctIV_tmp[i + 2] + dctIV_tmp[18 - (i + 2) - 1];
        }

        /* fastsdct(sdct_tmp, &tmp[0]);  manual in-line */
        {
          a0 = sdct_tmp[3] + sdct_tmp[5];
          a1 = sdct_tmp[3] - sdct_tmp[5];
          a2 = sdct_tmp[6] + sdct_tmp[2];
          a3 = sdct_tmp[6] - sdct_tmp[2];
          a4 = sdct_tmp[1] + sdct_tmp[7];
          a5 = sdct_tmp[1] - sdct_tmp[7];
          a6 = sdct_tmp[8] + sdct_tmp[0];
          a7 = sdct_tmp[8] - sdct_tmp[0];

          a8  = a0  + a2;
          a9  = a0  - a2;
          a10 = a0  - a6;
          a11 = a2  - a6;
          a12 = a8  + a6;
          a13 = a1  - a3;
          a14 = a13 + a7;
          a15 = a3  + a7;
          a16 = a1  - a7;
          a17 = a1  + a3;

          m0 = mad_f_mul(a17, -c3);
          m1 = mad_f_mul(a16, -c0);
          m2 = mad_f_mul(a15, -c4);
          m3 = mad_f_mul(a14, -c1);
          m4 = mad_f_mul(a5,  -c1);
          m5 = mad_f_mul(a11, -c6);
          m6 = mad_f_mul(a10, -c5);
          m7 = mad_f_mul(a9,  -c2);

          a18 =     sdct_tmp[4] + a4;
          a19 = 2 * sdct_tmp[4] - a4;
          a20 = a19 + m5;
          a21 = a19 - m5;
          a22 = a19 + m6;
          a23 = m4  + m2;
          a24 = m4  - m2;
          a25 = m4  + m1;

          /* output to every other slot for convenience */

          tmp[ 0] = a18 + a12;
          tmp[ 2] = m0  - a25;
          tmp[ 4] = m7  - a20;
          tmp[ 6] = m3;
          tmp[ 8] = a21 - m6;
          tmp[10] = a24 - m1;
          tmp[12] = a12 - 2 * a18;
          tmp[14] = a23 + m0;
          tmp[16] = a22 + m7;
        } /* end fastsdct(sdct_tmp, &tmp[0]);  manual in-line */

        /* odd input butterfly and scaling */

        for (i = 0; i < 9; i += 3) {
          sdct_tmp[i + 0] = mad_f_mul(dctIV_tmp[i + 0] - dctIV_tmp[18 - (i + 0) - 1], sdct_scale[i + 0]);
          sdct_tmp[i + 1] = mad_f_mul(dctIV_tmp[i + 1] - dctIV_tmp[18 - (i + 1) - 1], sdct_scale[i + 1]);
          sdct_tmp[i + 2] = mad_f_mul(dctIV_tmp[i + 2] - dctIV_tmp[18 - (i + 2) - 1], sdct_scale[i + 2]);
        }

        /* fastsdct(sdct_tmp, &tmp[1]);   manual in-line */
        {
          for (i = 0; i < 17; i++)
            fast_y[i] = tmp[i+1];

          a0 = sdct_tmp[3] + sdct_tmp[5];
          a1 = sdct_tmp[3] - sdct_tmp[5];
          a2 = sdct_tmp[6] + sdct_tmp[2];
          a3 = sdct_tmp[6] - sdct_tmp[2];
          a4 = sdct_tmp[1] + sdct_tmp[7];
          a5 = sdct_tmp[1] - sdct_tmp[7];
          a6 = sdct_tmp[8] + sdct_tmp[0];
          a7 = sdct_tmp[8] - sdct_tmp[0];

          a8  = a0  + a2;
          a9  = a0  - a2;
          a10 = a0  - a6;
          a11 = a2  - a6;
          a12 = a8  + a6;
          a13 = a1  - a3;
          a14 = a13 + a7;
          a15 = a3  + a7;
          a16 = a1  - a7;
          a17 = a1  + a3;

          m0 = mad_f_mul(a17, -c3);
          m1 = mad_f_mul(a16, -c0);
          m2 = mad_f_mul(a15, -c4);
          m3 = mad_f_mul(a14, -c1);
          m4 = mad_f_mul(a5,  -c1);
          m5 = mad_f_mul(a11, -c6);
          m6 = mad_f_mul(a10, -c5);
          m7 = mad_f_mul(a9,  -c2);

          a18 =     sdct_tmp[4] + a4;
          a19 = 2 * sdct_tmp[4] - a4;
          a20 = a19 + m5;
          a21 = a19 - m5;
          a22 = a19 + m6;
          a23 = m4  + m2;
          a24 = m4  - m2;
          a25 = m4  + m1;

          /* output to every other slot for convenience */

          fast_y[ 0] = a18 + a12;
          fast_y[ 2] = m0  - a25;
          fast_y[ 4] = m7  - a20;
          fast_y[ 6] = m3;
          fast_y[ 8] = a21 - m6;
          fast_y[10] = a24 - m1;
          fast_y[12] = a12 - 2 * a18;
          fast_y[14] = a23 + m0;
          fast_y[16] = a22 + m7;

          for (i = 0; i < 17; i++)
            tmp[i+1] = fast_y[i];
        } /* end fastsdct(sdct_tmp, &tmp[0]);  manual in-line */

        /* output accumulation */

        for (i = 3; i < 18; i += 8) {
          tmp[i + 0] -= tmp[(i + 0) - 2];
          tmp[i + 2] -= tmp[(i + 2) - 2];
          tmp[i + 4] -= tmp[(i + 4) - 2];
          tmp[i + 6] -= tmp[(i + 6) - 2];
        }
      } /* end sdctII(dctIV_tmp, tmp);  manual in-line */

      /* scale reduction and output accumulation */

// emulate a signed division 
#define RSHIFT1(x) (x < 0 ? (-(-x >> 1)) : (x>>1))
      tmp[0] = RSHIFT1(tmp[0]);
      for (i = 1; i < 17; i += 4) {
        tmp[i + 0] = RSHIFT1(tmp[i + 0]) - tmp[(i + 0) - 1];
        tmp[i + 1] = RSHIFT1(tmp[i + 1]) - tmp[(i + 1) - 1];
        tmp[i + 2] = RSHIFT1(tmp[i + 2]) - tmp[(i + 2) - 1];
        tmp[i + 3] = RSHIFT1(tmp[i + 3]) - tmp[(i + 3) - 1];
      }
      tmp[17] = RSHIFT1(tmp[17]) - tmp[16];
#undef RSHIFT1
    } /*  end dctIV(x, tmp); manual in-line */

    /* convert 18-point DCT-IV to 36-point IMDCT */

    for (i =  0; i <  9; i += 3) {
      y[i + 0] =  tmp[9 + (i + 0)];
      y[i + 1] =  tmp[9 + (i + 1)];
      y[i + 2] =  tmp[9 + (i + 2)];
    }
    for (i =  9; i < 27; i += 3) {
      y[i + 0] = -tmp[36 - (9 + (i + 0)) - 1];
      y[i + 1] = -tmp[36 - (9 + (i + 1)) - 1];
      y[i + 2] = -tmp[36 - (9 + (i + 2)) - 1];
    }
    for (i = 27; i < 36; i += 3) {
      y[i + 0] = -tmp[(i + 0) - 27];
      y[i + 1] = -tmp[(i + 1) - 27];
      y[i + 2] = -tmp[(i + 2) - 27];
    }
        send_P_ID_rpcm_imdct36_P_ID_mp3_main(y,sizeof(mad_fixed_t[36]));
  }

}

#endif // SC
