#include "HuffEncode_aux.h"

void huffencode() {
	int i,  j,  num_mdu;
	int in_block[64];

	imageheight=480;
	imagewidth=640;

	JpegDefaultHuffman();
	WriteMarker(0xd8);
	WriteAPP0();
	WriteSOF();
	WriteDQT();
	WriteDHT();
	WriteSOS();
	num_mdu = ((imageheight + 7) >> 3) * ((imagewidth + 7 >> 3));
	for (i = 0; i < num_mdu; i++)
	{
		recv_z2h(in_block,sizeof(int[64]));
		for(j = 0; j < 64 ; j++)
		{
			input[j] = in_block[j];
		}
		EncodeDC();
		EncodeAC();
	}
	WriteBits(-1,  0);
	WriteMarker(0xd9);
	fprintf(stderr,"Writing Encoded Data....\n");
	FileWrite();
	fprintf(stderr,"JPEG Encoding Completed!\n");
	system("xview ./output.jpg&");
	exit_simulation();
}
